Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Makefile.am	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -1,25 +1,210 @@
-ATOMSOURCE = atom.cpp atom_atominfo.cpp atom_bondedparticle.cpp atom_bondedparticleinfo.cpp atom_graphnode.cpp atom_graphnodeinfo.cpp atom_particleinfo.cpp atom_trajectoryparticle.cpp atom_trajectoryparticleinfo.cpp
-ATOMHEADER = atom.hpp atom_atominfo.hpp atom_bondedparticle.hpp atom_bondedparticleinfo.hpp atom_graphnode.hpp atom_graphnodeinfo.hpp atom_particleinfo.hpp atom_trajectoryparticle.hpp atom_trajectoryparticleinfo.hpp
-
-LINALGSOURCE = gslmatrix.cpp gslvector.cpp linearsystemofequations.cpp
-LINALGHEADER = gslmatrix.hpp gslvector.hpp linearsystemofequations.hpp
-
-ANALYSISSOURCE = analysis_bonds.cpp analysis_correlation.cpp
-ANALYSISHEADER = analysis_bonds.hpp analysis_correlation.hpp
-
-ACTIONSSOURCE = Actions/Action.cpp Actions/Process.cpp Actions/MethodAction.cpp Actions/ActionSequence.cpp Actions/MakroAction.cpp Actions/ErrorAction.cpp Actions/small_actions.cpp Actions/ActionRegistry.cpp 
-ACTIONSHEADER = Actions/Action.hpp Actions/Process.hpp Actions/MethodAction.hpp Actions/ActionSequence.hpp Actions/MakroAction.hpp Actions/ErrorAction.hpp Actions/small_actions.hpp Actions/ActionRegistry.hpp
-
-PATTERNSOURCE = Patterns/Observer.cpp
-PATTERNHEADER = Patterns/Observer.hpp Patterns/Cacheable.hpp
-
-VIEWSOURCE = Views/View.cpp Views/StringView.cpp Views/MethodStringView.cpp Views/StreamStringView.cpp
-VIEWHEADER = Views/View.hpp Views/StringView.hpp Views/MethodStringView.hpp Views/StreamStringView.hpp
-
-MENUSOURCE = Menu/Menu.cpp Menu/TextMenu.cpp Menu/MenuItem.cpp Menu/SubMenuItem.cpp Menu/ActionMenuItem.cpp Menu/SeperatorItem.cpp Menu/DisplayMenuItem.cpp
-MENUHEADER = Menu/Menu.hpp Menu/TextMenu.hpp Menu/MenuItem.hpp Menu/SubMenuItem.hpp Menu/ActionMenuItem.hpp Menu/SeperatorItem.hpp Menu/DisplayMenuItem.hpp
-
-UISOURCE = ${ACTIONSSOURCE} ${VIEWSOURCE} ${MENUSOURCE} UIElements/UIFactory.cpp UIElements/TextUIFactory.cpp UIElements/MainWindow.cpp UIElements/TextWindow.cpp UIElements/TextStatusIndicator.cpp UIElements/Dialog.cpp UIElements/TextDialog.cpp
-UIHEADER = ${ACTIONSHEADER} ${VIEWHEADER} ${MENUHEADER} UIElements/UIFactory.hpp UIElements/TextUIFactory.hpp UIElements/MainWindow.hpp UIElements/TextWindow.hpp UIElements/TextStatusIndicator.hpp UIElements/Dialog.hpp UIElements/TextDialog.hpp
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+# this includes source files that need to be present at multiple points
+HELPERSOURCE =  \
+  Helpers/Assert.cpp \
+  Helpers/MemDebug.cpp
+		        
+ATOMSOURCE = \
+  atom.cpp \
+  atom_atominfo.cpp \
+  atom_bondedparticle.cpp \
+  atom_bondedparticleinfo.cpp \
+  atom_graphnode.cpp \
+  atom_graphnodeinfo.cpp \
+  atom_particleinfo.cpp \
+  atom_trajectoryparticle.cpp \
+  atom_trajectoryparticleinfo.cpp
+ATOMHEADER = \
+  atom.hpp \
+  atom_atominfo.hpp \
+  atom_bondedparticle.hpp \
+  atom_bondedparticleinfo.hpp \
+  atom_graphnode.hpp \
+  atom_graphnodeinfo.hpp \
+  atom_particleinfo.hpp \
+  atom_trajectoryparticle.hpp \
+  atom_trajectoryparticleinfo.hpp
+
+LINALGSOURCE = \
+  ${HELPERSOURCE} \
+  gslmatrix.cpp \
+  gslvector.cpp \
+  linearsystemofequations.cpp \
+  Space.cpp \
+  vector.cpp
+			   
+LINALGHEADER = gslmatrix.hpp \
+  gslvector.hpp \
+  linearsystemofequations.hpp \
+  Space.hpp \
+  vector.hpp
+			   
+ANALYSISSOURCE = \
+  analysis_bonds.cpp \
+  analysis_correlation.cpp
+ANALYSISHEADER = \
+  analysis_bonds.hpp \
+  analysis_correlation.hpp
+
+ACTIONSSOURCE = Actions/Action.cpp \
+  ${ATOMACTIONSOURCE} \
+  ${CMDACTIONSOURCE} \
+  ${FRAGMENTATIONACTIONSOURCE} \
+  ${MOLECULEACTIONSOURCE} \
+  ${PARSERACTIONSOURCE} \
+  ${TESSELATIONACTIONSOURCE} \
+  Actions/ActionHistory.cpp \
+  Actions/ActionRegistry.cpp \
+  Actions/ActionSequence.cpp \
+  Actions/ErrorAction.cpp \
+  Actions/MakroAction.cpp \
+  Actions/ManipulateAtomsProcess.cpp \
+  Actions/MethodAction.cpp \
+  Actions/Process.cpp
+
+ACTIONSHEADER = Actions/Action.hpp \
+  ${ATOMACTIONHEADER} \
+  ${CMDACTIONHEADER} \
+  ${FRAGMENTATIONACTIONHEADER} \
+  ${MOLECULEACTIONHEADER} \
+  ${PARSERACTIONHEADER} \
+  ${TESSELATIONACTIONHEADER} \
+  Actions/ActionHistory.hpp \
+  Actions/ActionRegistry.hpp \
+  Actions/ActionSequence.hpp \
+  Actions/Calculation.hpp \
+  Actions/Calculation_impl.hpp \
+  Actions/ErrorAction.hpp \
+  Actions/MakroAction.hpp \
+  Actions/ManipulateAtomsProcess.hpp \
+  Actions/MethodAction.hpp \
+  Actions/Process.hpp
+  
+ATOMACTIONSOURCE =
+#  Actions/AtomAction/SomeAction.cpp               
+ATOMACTIONHEADER =
+#  Actions/AtomAction/SomeAction.hpp
+
+CMDACTIONSOURCE = \
+  Actions/CmdAction/HelpAction.cpp \
+  Actions/CmdAction/VersionAction.cpp
+CMDACTIONHEADER = \
+  Actions/CmdAction/HelpAction.hpp \
+  Actions/CmdAction/VersionAction.hpp
+
+FRAGMENTATIONACTIONSOURCE = 
+#  Actions/FragmentationAction/SomeAction.cpp               
+FRAGMENTATIONACTIONHEADER =
+#  Actions/FragmentationAction/SomeAction.hpp
+
+MOLECULEACTIONSOURCE = \
+  Actions/MoleculeAction/ChangeNameAction.cpp
+MOLECULEACTIONHEADER = \
+  Actions/MoleculeAction/ChangeNameAction.hpp
+                 
+PARSERACTIONSOURCE = \
+  Actions/ParserAction/LoadXyzAction.cpp \
+  Actions/ParserAction/SaveXyzAction.cpp       
+PARSERACTIONHEADER = \
+  Actions/ParserAction/LoadXyzAction.hpp \
+  Actions/ParserAction/SaveXyzAction.hpp
+
+TESSELATIONACTIONSOURCE =
+#  Actions/TesselationAction/SomeAction.cpp               
+TESSELATIONACTIONHEADER =
+#  Actions/TesselationAction/SomeAction.hpp
+
+PARSERSOURCE = \
+  Parser/ChangeTracker.cpp \
+  Parser/FormatParser.cpp \
+  Parser/TremoloParser.cpp \
+  Parser/XyzParser.cpp
+PARSERHEADER = \
+  Parser/ChangeTracker.hpp \
+  Parser/FormatParser.hpp \
+  Parser/TremoloParser.hpp \
+  Parser/XyzParser.hpp
+
+PATTERNSOURCE = \
+  Patterns/Observer.cpp
+PATTERNHEADER = \
+  Patterns/Cacheable.hpp \
+  Patterns/Observer.hpp \
+  Patterns/Singleton.hpp
+
+# Below is all for the User Interface
+
+VIEWSOURCE = \
+  Views/View.cpp \
+  Views/StringView.cpp \
+  Views/MethodStringView.cpp \
+  Views/StreamStringView.cpp
+VIEWHEADER = \
+  Views/View.hpp \
+  Views/StringView.hpp \
+  Views/MethodStringView.hpp \
+  Views/StreamStringView.hpp
+
+MENUSOURCE = \
+  Menu/Menu.cpp \
+  Menu/TextMenu.cpp \
+  Menu/MenuItem.cpp \
+  Menu/SubMenuItem.cpp \
+  Menu/ActionMenuItem.cpp \
+  Menu/SeperatorItem.cpp \
+  Menu/DisplayMenuItem.cpp
+  
+MENUHEADER = \
+  Menu/Menu.hpp \
+  Menu/TextMenu.hpp \
+  Menu/MenuItem.hpp \
+  Menu/SubMenuItem.hpp \
+  Menu/ActionMenuItem.hpp \
+  Menu/SeperatorItem.hpp \
+  Menu/DisplayMenuItem.hpp
+
+UISOURCE = \
+  ${ACTIONSSOURCE} \
+  ${COMMANDLINEUISOURCE} \
+  ${MENUSOURCE} \
+  ${TEXTUISOURCE} \
+  ${VIEWSOURCE} \
+  UIElements/Dialog.cpp \
+  UIElements/MainWindow.cpp \
+  UIElements/UIFactory.cpp
+  
+UIHEADER = \
+  ${ACTIONSHEADER} \
+  ${COMMANDLINEUIHEADER} \
+  ${MENUHEADER} \
+  ${TEXTUIHEADER} \
+  ${VIEWHEADER} \
+  UIElements/Dialog.hpp \
+  UIElements/MainWindow.hpp \
+  UIElements/UIFactory.hpp
+
+TEXTUISOURCE = \
+  UIElements/TextDialog.cpp \
+  UIElements/TextStatusIndicator.cpp \
+  UIElements/TextUIFactory.cpp \
+  UIElements/TextWindow.cpp
+TEXTUIHEADER = \
+  UIElements/TextDialog.hpp \
+  UIElements/TextStatusIndicator.hpp \
+  UIElements/TextUIFactory.hpp \
+  UIElements/TextWindow.hpp
+
+COMMANDLINEUISOURCE = \
+  UIElements/CommandLineDialog.cpp \
+  UIElements/CommandLineStatusIndicator.cpp \
+  UIElements/CommandLineUIFactory.cpp \
+  UIElements/CommandLineWindow.cpp
+COMMANDLINEUIHEADER = \
+  UIElements/CommandLineDialog.hpp \
+  UIElements/CommandLineStatusIndicator.hpp \
+  UIElements/CommandLineUIFactory.hpp \
+  UIElements/CommandLineWindow.hpp
 
 # all these files are only used for legacy reasons while the transition is in progress
@@ -29,9 +214,113 @@
 LEGACYHEADER = Legacy/oldmenu.hpp
 
-DESCRIPTORSOURCE = Descriptors/AtomDescriptor.cpp Descriptors/AtomIdDescriptor.cpp
-DESCRIPTORHEADER = Descriptors/AtomDescriptor.hpp Descriptors/AtomIdDescriptor.hpp
-
-SOURCE = ${ANALYSISSOURCE} ${ATOMSOURCE} ${PATTERNSOURCE} ${UISOURCE} ${DESCRIPTORSOURCE} ${LEGACYSOURCE} bond.cpp bondgraph.cpp boundary.cpp config.cpp element.cpp ellipsoid.cpp errorlogger.cpp graph.cpp helpers.cpp info.cpp leastsquaremin.cpp linkedcell.cpp log.cpp logger.cpp memoryusageobserver.cpp moleculelist.cpp molecule.cpp molecule_dynamics.cpp molecule_fragmentation.cpp molecule_geometry.cpp molecule_graph.cpp molecule_pointcloud.cpp parser.cpp periodentafel.cpp tesselation.cpp tesselationhelpers.cpp vector.cpp verbose.cpp World.cpp 
-HEADER = ${ANALYSISHEADER} ${ATOMHEADER} ${PATTERNHEADER} ${UIHEADER} ${DESCRIPTORHEADER} ${LEGACYHEADER} bond.hpp bondgraph.hpp boundary.hpp config.hpp defs.hpp element.hpp ellipsoid.hpp errorlogger.hpp graph.hpp helpers.hpp info.hpp leastsquaremin.hpp linkedcell.hpp lists.hpp log.hpp logger.hpp memoryallocator.hpp memoryusageobserver.hpp molecule.hpp molecule_template.hpp parser.hpp periodentafel.hpp stackclass.hpp tesselation.hpp tesselationhelpers.hpp vector.hpp verbose.hpp World.hpp 
+DESCRIPTORSOURCE = Descriptors/AtomDescriptor.cpp \
+  Descriptors/AtomIdDescriptor.cpp \
+  Descriptors/AtomTypeDescriptor.cpp \
+  Descriptors/MoleculeDescriptor.cpp \
+  Descriptors/MoleculeIdDescriptor.cpp 
+				   
+				   
+DESCRIPTORHEADER = Descriptors/AtomDescriptor.hpp \
+  Descriptors/AtomIdDescriptor.hpp \
+  Descriptors/AtomTypeDescriptor.hpp \
+  Descriptors/MoleculeDescriptor.hpp \
+  Descriptors/MoleculeIdDescriptor.hpp
+				   
+EXCEPTIONSOURCE = Exceptions/CustomException.cpp \
+  Exceptions/LinearDependenceException.cpp \
+  Exceptions/MathException.cpp \
+  Exceptions/ZeroVectorException.cpp
+				  
+EXCEPTIONHEADER = Exceptions/CustomException.hpp \
+  Exceptions/LinearDependenceException.hpp \
+  Exceptions/MathException.hpp \
+  Exceptions/ZeroVectorException.hpp
+
+SOURCE = \
+  ${ANALYSISSOURCE} \
+  ${ATOMSOURCE} \
+  ${PATTERNSOURCE} \
+  ${PARSERSOURCE} \
+  ${UISOURCE} \
+  ${DESCRIPTORSOURCE} \
+  ${HELPERSOURCE} \
+  ${LEGACYSOURCE} \
+  ${EXCEPTIONSOURCE} \
+  bond.cpp \
+  bondgraph.cpp \
+  boundary.cpp \
+  CommandLineParser.cpp \
+  config.cpp \
+  element.cpp \
+  ellipsoid.cpp \
+  errorlogger.cpp \
+  graph.cpp \
+  helpers.cpp \
+  info.cpp \
+  leastsquaremin.cpp \
+  Line.cpp \
+  linkedcell.cpp \
+  lists.cpp \
+  log.cpp \
+  logger.cpp \
+  memoryusageobserver.cpp \
+  moleculelist.cpp \
+  molecule.cpp \
+  molecule_dynamics.cpp \
+  molecule_fragmentation.cpp \
+  molecule_geometry.cpp \
+  molecule_graph.cpp \
+  molecule_pointcloud.cpp \
+  parser.cpp \
+  periodentafel.cpp \
+  Plane.cpp \
+  tesselation.cpp \
+  tesselationhelpers.cpp \
+  triangleintersectionlist.cpp \
+  verbose.cpp \
+  vector_ops.cpp \
+  World.cpp
+
+HEADER = \
+  ${ANALYSISHEADER} \
+  ${ATOMHEADER} \
+  ${PARSERHEADER} \
+  ${PATTERNHEADER} \
+  ${UIHEADER} \
+  ${DESCRIPTORHEADER} \
+  ${EXCEPTIONHEADER} \
+  ${LEGACYHEADER} \
+  bond.hpp \
+  bondgraph.hpp \
+  boundary.hpp \
+  CommandLineParser.hpp \
+  config.hpp \
+  defs.hpp \
+  element.hpp \
+  ellipsoid.hpp \
+  errorlogger.hpp \
+  graph.hpp \
+  helpers.hpp \
+  info.hpp \
+  leastsquaremin.hpp \
+  Line.hpp \
+  linkedcell.hpp \
+  lists.hpp \
+  log.hpp \
+  logger.hpp \
+  memoryallocator.hpp \
+  memoryusageobserver.hpp \
+  molecule.hpp \
+  molecule_template.hpp \
+  parser.hpp \
+  periodentafel.hpp \
+  Plane.hpp \
+  stackclass.hpp \
+  tesselation.hpp \
+  tesselationhelpers.hpp \
+  triangleintersectionlist.hpp \
+  verbose.hpp \
+  vector_ops.hpp \
+  World.hpp 
 
 BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB)
@@ -41,19 +330,14 @@
 bin_PROGRAMS = molecuilder joiner analyzer
 molecuilderdir = ${bindir}
-#libmolecuilder_a_CXXFLAGS = -DNO_CACHING
 libmolecuilder_a_SOURCES = ${SOURCE} ${HEADER}
 libgslwrapper_a_SOURCES = ${LINALGSOURCE} ${LINALGHEADER}
 molecuilder_DATA = elements.db valence.db orbitals.db Hbonddistance.db Hbondangle.db
 molecuilder_LDFLAGS = $(BOOST_LDFLAGS)
-molecuilder_CXXFLAGS = $(BOOST_CPPFLAGS)
-#molecuilder_CXXFLAGS += -DNO_CACHING
 molecuilder_SOURCES = builder.cpp
-molecuilder_LDADD = libmolecuilder.a libgslwrapper.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
+molecuilder_LDADD = libmolecuilder.a libgslwrapper.a $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB}
 joiner_SOURCES = joiner.cpp datacreator.cpp parser.cpp datacreator.hpp helpers.hpp parser.hpp periodentafel.hpp
 joiner_LDADD = libmolecuilder.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
 analyzer_SOURCES = analyzer.cpp datacreator.cpp parser.cpp helpers.hpp periodentafel.hpp parser.hpp datacreator.hpp 
 analyzer_LDADD = libmolecuilder.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
-
-#EXTRA_DIST = ${molecuilder_DATA}
 
 FORCE:
Index: src/Menu/ActionMenuItem.hpp
===================================================================
--- src/Menu/ActionMenuItem.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Menu/ActionMenuItem.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -26,4 +26,6 @@
   virtual void doTrigger();
 
+  virtual bool isActive();
+
 private:
   Action* action; //!< this action will be called when the trigger matches
Index: src/Menu/MenuItem.cpp
===================================================================
--- src/Menu/MenuItem.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Menu/MenuItem.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -78,2 +78,6 @@
   return added;
 }
+
+bool MenuItem::isActive(){
+  return true;
+}
Index: src/Menu/MenuItem.hpp
===================================================================
--- src/Menu/MenuItem.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Menu/MenuItem.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -21,9 +21,4 @@
  */
 class MenuItem {
-private:
-  char trigger;
-  string *description;
-  bool added;
-
 public:
   MenuItem(char,const char*,Menu*);
@@ -41,6 +36,13 @@
   bool wasAdded();
 
+  virtual bool isActive();
+
 protected:
   void setDescription(string);
+
+private:
+  char trigger;
+  string *description;
+  bool added;
 };
 
Index: src/Menu/TextMenu.cpp
===================================================================
--- src/Menu/TextMenu.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Menu/TextMenu.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -11,4 +11,5 @@
 #include "Menu/TextMenu.hpp"
 #include "Menu/MenuItem.hpp"
+#include "Helpers/Assert.hpp"
 
 
@@ -18,10 +19,10 @@
  */
 TextMenu::TextMenu(ostream& _outputter, string _title, char _spacer,int _length) :
-outputter(_outputter),
-title(_title),
-spacer(_spacer),
-length(_length),
-quit(false),
-defaultItem(0)
+  defaultItem(0),
+  outputter(_outputter),
+  title(_title),
+  spacer(_spacer),
+  length(_length),
+  quit(false)
 {
 }
@@ -51,5 +52,12 @@
 
 void TextMenu::showEntry(MenuItem* entry){
-  outputter << entry->formatEntry() << "\n";
+  if(entry->isActive()==false){
+    outputter << "(";
+  }
+  outputter << entry->formatEntry();
+  if(entry->isActive()==false){
+    outputter << ")";
+  }
+  outputter << "\n";
 }
 
@@ -74,5 +82,7 @@
     list<MenuItem*>::iterator iter;
     for(iter = items.begin(); iter!=items.end();iter++){
-      somethingChosen |= (*iter)->checkTrigger(choice);
+      if((*iter)->isActive()){
+        somethingChosen |= (*iter)->checkTrigger(choice);
+      }
     }
     // see if something was chosen and call default Item if not
@@ -88,5 +98,44 @@
 }
 
+string TextMenu::getTitle(){
+  return title;
+}
+
 void TextMenu::addDefault(MenuItem* _defaultItem) {
   defaultItem = _defaultItem;
 }
+
+/****************************** Contained Actions ****************/
+
+const string TextMenu::LeaveAction::nameBase = "Leave menu: ";
+
+TextMenu::LeaveAction::LeaveAction(TextMenu* _menu) :
+Action(nameBase+_menu->getTitle()),
+menu(_menu)
+{}
+
+TextMenu::LeaveAction::~LeaveAction(){}
+
+bool TextMenu::LeaveAction::canUndo(){
+  return false;
+}
+
+bool TextMenu::LeaveAction::shouldUndo(){
+  return false;
+}
+
+Action::state_ptr TextMenu::LeaveAction::performCall(){
+  menu->doQuit();
+  return Action::success;
+}
+
+
+Action::state_ptr TextMenu::LeaveAction::performUndo(Action::state_ptr){
+  ASSERT(0,"Cannot undo leaving a menu");
+  return Action::success;
+}
+
+Action::state_ptr TextMenu::LeaveAction::performRedo(Action::state_ptr){
+  ASSERT(0,"Cannot redo leaving a menu");
+  return Action::success;
+}
Index: src/Menu/TextMenu.hpp
===================================================================
--- src/Menu/TextMenu.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Menu/TextMenu.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -14,4 +14,5 @@
 
 #include "Menu/Menu.hpp"
+#include "Actions/Action.hpp"
 #include "defs.hpp"
 
@@ -26,4 +27,22 @@
 {
 public:
+  class LeaveAction : public Action {
+  public:
+    LeaveAction(TextMenu*);
+    virtual ~LeaveAction();
+
+    bool canUndo();
+    bool shouldUndo();
+
+  private:
+    virtual Action::state_ptr performCall();
+    virtual Action::state_ptr performUndo(Action::state_ptr);
+    virtual Action::state_ptr performRedo(Action::state_ptr);
+
+    TextMenu* menu;
+
+    static const string nameBase;
+  };
+
   TextMenu(ostream& _outputter, string _title, char _spacer=STD_MENU_TITLE_SPACER,int _length=STD_MENU_LENGTH);
   virtual ~TextMenu();
@@ -32,4 +51,5 @@
   virtual void removeItem(MenuItem*);
   virtual void display();
+  virtual string getTitle();
 
   /**
Index: src/Parser/ChangeTracker.cpp
===================================================================
--- src/Parser/ChangeTracker.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Parser/ChangeTracker.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,73 @@
+/*
+ * ChangeTracker.cpp
+ *
+ *  Created on: Mar 1, 2010
+ *      Author: metzler
+ */
+
+#include "ChangeTracker.hpp"
+
+ChangeTracker* ChangeTracker::instance = NULL;
+
+/**
+ * Constructor. Signs on as an observer for the World.
+ */
+ChangeTracker::ChangeTracker() {
+  isConsistent = true;
+  World::getInstance().signOn(this);
+}
+
+/**
+ * Destructor. Signs off from the World.
+ */
+ChangeTracker::~ChangeTracker() {
+  World::getInstance().signOff(this);
+}
+
+/**
+ * Returns the change tracker instance.
+ *
+ * \return this
+ */
+ChangeTracker* ChangeTracker::get() {
+  if (instance == NULL) {
+    instance = new ChangeTracker();
+  }
+
+  return instance;
+}
+
+/**
+ * Destroys the change tracker instance. Be careful, the change tracker is a
+ * singleton and destruction might lead to a loss of consistency.
+ */
+void ChangeTracker::destroy() {
+  delete instance;
+  instance = NULL;
+}
+
+/**
+ * With this, the World can update the change tracker's state.
+ */
+void ChangeTracker::update(Observable *publisher) {
+  isConsistent = false;
+}
+
+/**
+ * Gets whether there are non-saved changes.
+ *
+ * \param true if there are any changes, false otherwise
+ */
+bool ChangeTracker::hasChanged() {
+  return !isConsistent;
+}
+
+/**
+ * Tells all observers (which are the different parsers) that they are supposed
+ * to save the current state.
+ */
+void ChangeTracker::saveStatus() {
+  if (hasChanged()) {
+    notifyAll();
+  }
+}
Index: src/Parser/ChangeTracker.hpp
===================================================================
--- src/Parser/ChangeTracker.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Parser/ChangeTracker.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,37 @@
+/*
+ * ChangeTracker.hpp
+ *
+ *  Created on: Mar 1, 2010
+ *      Author: metzler
+ */
+
+#ifndef CHANGETRACKER_HPP_
+#define CHANGETRACKER_HPP_
+
+#include "Patterns/Observer.hpp"
+#include "World.hpp"
+
+using namespace std;
+
+/**
+ * Observes the world and notifies subscribers via saveStatus if there are
+ * changes to it.
+ */
+class ChangeTracker : public Observable {
+public:
+  void saveStatus();
+  static ChangeTracker* get();
+  static void destroy();
+
+protected:
+  void update(Observable *publisher);
+  bool hasChanged();
+
+private:
+  bool isConsistent;
+  static ChangeTracker* instance;
+  ChangeTracker();
+  ~ChangeTracker();
+};
+
+#endif /* CHANGETRACKER_HPP_ */
Index: src/Parser/FormatParser.cpp
===================================================================
--- src/Parser/FormatParser.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Parser/FormatParser.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,55 @@
+/*
+ * FormatParser.cpp
+ *
+ *  Created on: Mar 1, 2010
+ *      Author: metzler
+ */
+
+#include "FormatParser.hpp"
+#include <iostream>
+
+using namespace std;
+
+/**
+ * Constructor.
+ */
+FormatParser::FormatParser() {
+  ChangeTracker::get()->signOn(this);
+  saveStream = NULL;
+}
+
+/**
+ * Destructor.
+ */
+FormatParser::~FormatParser() {
+  ChangeTracker::get()->signOff(this);
+}
+
+/**
+ * Update operation which can be invoked by the observable (which should be the
+ * change tracker here).
+ */
+void FormatParser::update(Observable *publisher) {
+  if (!saveStream) {
+    cerr << "Please invoke setOstream() so the parser knows where to save the World's data." << endl;
+    return;
+  }
+
+  save(saveStream);
+}
+
+/**
+ * The observable can tell when it dies.
+ */
+void FormatParser::subjectKilled(Observable *publisher) {}
+
+
+/**
+ * Sets the output stream for save, so the save() method can be invoked on update
+ * automatically.
+ *
+ * \param ostream where to save the World's state
+ */
+void FormatParser::setOstream(ostream* output) {
+  saveStream = output;
+}
Index: src/Parser/FormatParser.hpp
===================================================================
--- src/Parser/FormatParser.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Parser/FormatParser.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,32 @@
+/*
+ * FormatParser.hpp
+ *
+ *  Created on: Mar 1, 2010
+ *      Author: metzler
+ */
+
+#ifndef FORMATPARSER_HPP_
+#define FORMATPARSER_HPP_
+
+#include "Patterns/Observer.hpp"
+#include "ChangeTracker.hpp"
+#include "parser.hpp"
+
+/**
+ * General parser which observes the change tracker.
+ */
+class FormatParser : public Observer {
+public:
+  FormatParser();
+  virtual ~FormatParser();
+  virtual void save(std::ostream* file)=0;
+  virtual void load(std::istream* file)=0;
+  void setOstream(std::ostream* file);
+  void update(Observable *publisher);
+  void subjectKilled(Observable *publisher);
+
+private:
+  std::ostream* saveStream;
+};
+
+#endif /* FORMATPARSER_HPP_ */
